#include <iostream>
#include <vector>
#include <queue>

struct edge {
    int a, b, t, l, v, psv, pst;

    edge(int x, int y, int z, int p)
    {
        a = x;
        b = y;
        pst = t = z != 0 ? (p * 1e7) / z : -1;
        psv = v = z;
        l = p;
    }

    void print()
    {
        std::cout << a << ' ' << b << ' ' << pst << ' ' << v << ' ' << t << ' ' << psv << " " << l << '\n';
    }

    bool operator <(edge other) const
    {
        return this->pst > other.pst;
    }
};

const int MAX_N = 200;

std::vector<edge> edges[MAX_N];
std::vector<int> ans;

int best[MAX_N], from[MAX_N], curr_from[MAX_N];

std::priority_queue<edge> prq;

int main()
{
    for(int i = 1; i < MAX_N; ++ i)
    {
        best[i] = -1;
    }

    std::cin.tie();
    std::ios_base::sync_with_stdio(false);

    int n, m, s;
    std::cin >> n >> m >> s;

    for(int i = 0; i < m; ++ i)
    {
        int a, b, v, l;
        std::cin >> a >> b >> v >> l;
        edges[a].push_back(edge(a, b, v, l));
    }

    /*for(int i = 0; i < m; ++ i)
    {
        std::cout << ' ' << edges[i].b << ' ' << edges[i].t << '\n';
    }*/

    int curr_v = 70;

    for(int i = 0; i < edges[0].size(); ++ i)
    {
        if(edges[0][i].v == 0)
        {
            edges[0][i].psv = curr_v;
            edges[0][i].pst = (edges[0][i].l * 1e7) / curr_v;
        }
        prq.push(edges[0][i]);
        from[edges[0][i].b] = 0;
    }

    while(!prq.empty())
    {
        edge curr = prq.top();
        prq.pop();
        curr_v = curr.psv;
        curr_from[curr.b] = curr.a;

        //curr.print();
        if(best[curr.b] == -1 || best[curr.a] + curr.pst < best[curr.b])
        {
            from[curr.b] = curr.a;
            best[curr.b] = best[curr.a] + curr.pst;
            for(int i = 0; i < edges[curr.b].size(); ++ i)
            {
                if(edges[curr.b][i].v == 0)
                {
                    edges[curr.b][i].psv = curr_v;
                    edges[curr.b][i].pst = (edges[curr.b][i].l * 1e7) / curr_v;
                }
                prq.push(edges[curr.b][i]);
            }
            if(curr.b == s)
            {
                ans.resize(0);
                int ss = s;
                while(ss != 0)
                {
                    ans.push_back(curr_from[ss]);
                    ss = curr_from[ss];
                }
            }
        }
    }
    //std::cout << '\n';

    for(int i = ans.size() - 1; i >= 0; -- i)
    {
        std::cout << ans[i] << ' ';
    }

    std::cout << s << '\n';

    return 0;
}
/*
6 15 1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
*/
