#include<bits/stdc++.h>
using namespace std;

const double MAXVALUE = 5587500;

struct node{
    int v;
    double s, l;
    node() {}
    node(int _v, int _s, int _l){
        v = _v;
        s = _s;
        l = _l;
    }
};

bool operator<(node a, node b){
    if(a.s == 0) return false;
    if(b.s == 0) return true;
    return (a.l / a.s) > (b.l / b.s);
}

vector<node> g[200];
int n, m, e;
double dist[200];
int par[200];
bool used[200];

void dijkstra(int s){
    priority_queue<node> pq;
    for(int i = 0; i < n; i ++){
        dist[i] = MAXVALUE;
    }
    dist[s] = 0;
    pq.push(node(s, 70, 0));
    while(!pq.empty()){
        int s = pq.top().v;
        int v = pq.top().s;
        pq.pop();
        if(used[s] == true){
            continue;
        }
        used[s] = true;
        for(int i = 0; i < g[s].size(); i ++){
            int pointer = g[s][i].v;
            if(g[s][i].s == 0){
                g[s][i].s = v;
            }
            double weight = g[s][i].l / g[s][i].s;
            if(used[pointer] == false){
                if(dist[pointer] > dist[s] + weight){
                    dist[pointer] = dist[s] + weight;
                    par[pointer] = s;
                }
                pq.push(node(pointer, g[s][i].s, g[s][i].l));
            }
        }
    }
}

int main(){
    cin >> n >> m >> e;
    for(int i = 0; i < m; i ++){
        int a, b, v, l;
        cin >> a >> b >> v >> l;
        g[a].push_back(node(b, v, l));
    }
    dijkstra(0);
    vector<int> ans;
    while(e != 0){
        ans.push_back(e);
        e = par[e];
    }
    ans.push_back(0);
    reverse(ans.begin(), ans.end());
    for(int i = 0; i < ans.size(); i ++){
        cout << ans[i] << " ";
    }
}
/**
6 15 1
0 1 25 68
0 2 30 50
0 5 0 101
1 2 70 77
1 3 35 42
2 0 0 22
2 1 40 86
2 3 0 23
2 4 45 40
3 1 64 14
3 5 0 23
4 1 95 8
5 1 0 84
5 2 90 64
5 3 36 40
*/
